/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

 ////////////////////////////////////////////////////////////////////////////////////
////////   Single_entry holder and all_entries holder classes  /////////////////////


function _Clone(){
  var NewObj = new Object();
  for (var oP in this) NewObj[oP]=this[oP];
  return NewObj;
}

function _StoreInput(inp){
  var haslist = false;
	lst = new Object();
	inobj = new Object();
	inobj.name = String(inp.name);
	inobj.value = String(inp.value);
	if (inp.label) {inobj.label=inp.label} else {inobj.label=""};
	if (inp.grouptitle) {inobj.grouptitle=inp.grouptitle} else {inobj.grouptitle=""};
	inobj.priority = String(inp.priority);
	ItemName = inp.name;
	//ItemName = String(inp.priority);
	
	if (this.Inputs!=null){
		if (this.Inputs[ItemName]){
			haslist = true;
			if (!this.Inputs[ItemName].list) {
			  this.Inputs[ItemName].list = new Object();
			  this.Inputs[ItemName].list[this.Inputs[ItemName].def.priority] = this.Inputs[ItemName].def;
			}
			this.Inputs[ItemName].list[inp.priority] = inobj;
		}else{
			this.Inputs[ItemName] = new Object();
			this.Inputs[ItemName] = inobj;
			this.Inputs[ItemName].def = new Object();
			this.Inputs[ItemName].def = inobj;
			//this.Inputs[ItemName].list = new Object();
			//this.Inputs[ItemName].list[inp.priority] = inobj;
		}
	}else{
		this.Inputs = new Object();
		this.Inputs[ItemName] = new Object();
    this.Inputs[ItemName] = inobj;
		this.Inputs[ItemName].def = new Object();
		this.Inputs[ItemName].def = inobj;
	}
  return haslist;
}

function ProtoEntry() {
  this.eId =  "";
  this.Title = "";
  this.Action = "";
  this.Method = "";
  this.Desc =  "";
  //this.Inputs = new Object;
  this.Context = true;
  this.blocked = false;
  this.filepath = "";
  this.qcharset="UTF-8";
  this.showif = "";
  this.haslist = false;
  this._Clone = _Clone;
  this._StoreInput = _StoreInput;

	//watchers
	this.watch("Method",
	  function(id,oldval,newval){
	    if (!((newval != "POST") || (newval != "GET"))) newval = "GET";
	    return newval;
	  }
	)
}
ProtoEntry.prototype = ProtoEntry;

//Entries holder:
function _AddEntryObj(EntryObj, eId){
	eId = String(EntryObj.filepath).replace(/[\\\/\.:]/ig, "");
	if (!EntryObj.Title) EntryObj.Title = "Conquery Error!";
	//if (!EntryObj.Method) Method = "GET";
	//if (EntryObj.Context=="") EntryObj.Context = true;
  EntryObj.eId = eId;
  this[eId] = EntryObj._Clone();
  this._Empty = false;
  return eId;
}

function _UpdateEntry(EntryObj){
  for (each in EntryObj){
    if (each != "Inputs") this[each]=EntryObj[each]}
}
function _Exist(KeyName){
  var exst=false;
  if (this[KeyName]) exst=true; 
  return exst;
}
function _Item(KeyName){
	return this[KeyName];
}
function _Rm(Key){
    delete this[Key];
}
function _Items(){
try{
  var items = [];
  for (item in this) if ((item.substr(0,1) != "_") && (item.substr(0,9) != "prototype")) items[items.length] = this[item];
  items.sort(this._Cmp);
  return items;
}catch(er){cqerr(er, "_Items method")}
}
function _Cmp(a, b){
  if (a.Title.toLowerCase() > b.Title.toLowerCase()){return 1;}
  else if (a.Title.toLowerCase() < b.Title.toLowerCase()) {return -1;}
  else {return 0;}
}
function _Clear(){
  for (item in this) if (item.substr(0,1) != "_")	delete this[item];
  this._Empty = true;
}

function _ProtoHash(){
	this._Empty = true;
	this._AddEntryObj = _AddEntryObj;
	this._UpdateEntry = _UpdateEntry;
	this._Exist = _Exist;
	this._Item = _Item;
	this._Items = _Items;
	this._Rm = _Rm;
	this._Cmp = _Cmp;
	this._Clear = _Clear;
	this._Clone = _Clone;
}
_ProtoHash.prototype = _ProtoHash;
 /////// END classes ////////
////////////////////////////


 ////////////////////////////
//////// Globals ///////////

//Active Entries holder
var EntryHash = new _ProtoHash();
//Repository Entries holder
var repEntryHash = new _ProtoHash();

var QueryHash = new Object();
var AllFiles = [];
var curDirState = new Object();
var lastDirState = new Object();
var PlugsPath = GetMycroftDir();
var tst = "unchanged";

/// Prefs globals ///
var Prefs = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService).getBranch("conquery.");
var MenuPlace = "queryto";
var PlugsDir = "";
var LoadTabsInBg = false;
var UseHotMenu = false;
prfs_LoadMain();

function cqerr(r, msg){
alert ("ConQuery failed:\n"+msg+"\n"+r);
}

function plg_QuickLoadAll(){
  EntryHash._Clear();
  //lastDirState = rdir(PlugsPath);
  lastDirState = rdir(PlugsDir);
  for (each in lastDirState) {EntryHash._AddEntryObj(plg_quickread(each), "")}
}

function plg_quickread(filepath){
  var retItem = new ProtoEntry();
  var haslist = false;
  //retItem = new Object;
	filedata = cqReadFile(filepath);
	filedata = filedata.replace(/#.*/ig,"");
	filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
	SearchTagData = filedata.match(/<search.+?<\/search>/gi);
	mcSearch = GetTagsFromString("search", SearchTagData);
	//mcSearch = GetTagsFromString("search", filedata);
	if (mcSearch[0]){
		retItem.Title = mcSearch[0].name;
		retItem.Desc = mcSearch[0].description;
		retItem.showif = mcSearch[0].showif;
		if ((!retItem.Title) || (retItem.Title=="undefined")) {
		  retItem.Title = "zzzz!!! PARSEERROR: "+filepath;
		  retItem.Desc = filepath + " has no <search> tag or <search> tag not well formed!";
		}
		if ((!retItem.showif) || (retItem.showif=="undefined")) retItem.showif = "";
		if ((!retItem.Desc) || (retItem.Desc=="undefined")) retItem.Desc = "";
		retItem.filepath = filepath;
		retItem.Context = true;
	}else{
	  	retItem.eId = "";
	  	retItem.Title = "zzzz!!! PARSEERROR: "+filepath;
	  	retItem.Method = "GET";
	  	retItem.Desc = filepath + " has no <search> tag or <search> tag not well formed!";
	  	retItem.Context = "";
	  	retItem.FilePath = filepath;
	}
  return retItem;	
}


function rdir(dirname){
try{
  var arr = [];
  var dir = Components.classes["@mozilla.org/file/local;1"].
             createInstance(Components.interfaces.nsILocalFile);
  dir.initWithPath(dirname);
  if (dir.isDirectory()) {
      items = dir.directoryEntries;
  } else {
      cqerr(null, "Error reading directory:\n" + dirname);
      return arr;
  }

  items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
  while (items.hasMoreElements()) {
    var i = items.getNext();
    i.QueryInterface(Components.interfaces.nsIFile);
    if (i.isDirectory()){
    }else{
      var fn = i.leafName;
      var fx = fn.substr(fn.length - 4, fn.length).toLowerCase();
      if ((fx == ".cqr")||(fx == ".src")) {
        arr[i.path] = i.lastModifiedTime;
      }
    }
  }
return arr;
}catch(err){return arr}
}

function cqReadFile(filename) {
    var MODE_RDONLY = 0x01;
    var PERM_IRUSR = 00400;
    
    try {
        var file = Components.classes["@mozilla.org/file/local;1"].
                   createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(filename);
        if (file.exists() && file.isReadable()) {
            var is = Components.classes["@mozilla.org/network/file-input-stream;1"].
                     createInstance(Components.interfaces.nsIFileInputStream);
            is.init(file, MODE_RDONLY, PERM_IRUSR, 0);
            var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
                createInstance(Components.interfaces.nsIScriptableInputStream);
            sis.init(is);
            var data = sis.read(sis.available());
            sis.close();
            is.close();
            return data;
        }
        else {
            cqerr(null, "File" + filename + "read error in cqReadFile\n");
            return null;
        }
    }
    catch (er) {
        cqerr(er, "File" + filename + "read error in cqReadFile\n");
    }
    return null;
}

function GetMycroftDir(){
	var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var gChromeDir      = gDirServiceProp.get("AChrom",Components.interfaces.nsIFile);
	delim = "\\";
	if (gChromeDir.path.substr(0,1)=="/") delim = "/";
	patharr = gChromeDir.path.split(delim);
	patharr[patharr.length-1]="searchplugins";
	return patharr.join(delim);
}

function srcupdated() {
  var rval = false;
  var lastcnt = 0;
  var curcnt = 0;
  
  for (each in lastDirState) { lastcnt+=1 }
  for (each in curDirState) { curcnt+=1 }

  if (lastcnt != curcnt) {
    rval = true;
  } else {
    for (each in lastDirState) {
      if ((each != each)||(curDirState[each] != lastDirState[each])) {
        rval = true;
        break;
      }
    }
  }
  curDirState = lastDirState;
  return rval;
}

function prfs_LoadMain(){
  MenuPlace = prfs_ReadItem("Main.MenuPlace");
  PlugsDir = prfs_ReadItem("Main.PlugsDir");
  LoadTabsInBg = prfs_ReadItem("Main.LoadTabsInBg");
  UseHotMenu = prfs_ReadItem("Main.UseHotMenu");
  if (!PlugsDir) PlugsDir = GetMycroftDir();
}

function prfs_SaveMain(){
  //alert(document.getElementById("prfs_plugsdir").value)
  Prefs.setCharPref("Main.MenuPlace", MenuPlace);
  PlugsDir = document.getElementById("prfs_plugsdir").value;
  LoadTabsInBg = document.getElementById("loadinbg").checked;
  UseHotMenu = document.getElementById("enhotmenu").checked;
  
  Prefs.setCharPref("Main.PlugsDir", PlugsDir);
  Prefs.setBoolPref("Main.LoadTabsInBg", LoadTabsInBg);
  Prefs.setBoolPref("Main.UseHotMenu", UseHotMenu);
}

function prfs_LoadEntries(){
try{
  //EntryHash._Clear();
  var entries = new Object();
  //var entry = new ProtoEntry();
  var prfs = Prefs.getChildList("Entries.", {value: 0});
    for (p in prfs){
      tmp = prfs[p].split(".");
      entries[tmp[1]] = "";
    }
  for (it in entries){
    entry = new ProtoEntry();
    entry.eId       = prfs_ReadItem("Entries."+it+".eId");
    entry.Title     = prfs_ReadItem("Entries."+it+".Title");
    entry.Method    = prfs_ReadItem("Entries."+it+".Method");
    entry.Desc      = prfs_ReadItem("Entries."+it+".Desc");
    entry.Context   = prfs_ReadItem("Entries."+it+".Context");
    entry.blocked    = prfs_ReadItem("Entries."+EntryId+".blocked");
    entry.showif    = prfs_ReadItem("Entries."+it+".showif");
    //entry.haslist = prfs_ReadItem("Entries."+it+".haslist");
    entry.filepath  = prfs_ReadItem("Entries."+it+".filepath");
    EntryHash._AddEntryObj(entry, entry.eId);
  }
}catch(er){cqerr(er, "prfs_LoadEntries sub")}
}

function prfs_LoadEntry(EntryId){
try{
  if (Prefs.prefHasUserValue("Entries."+EntryId+".Title")) {
    entry = new ProtoEntry();
    entry.Context   = prfs_ReadItem("Entries."+EntryId+".Context");
    entry.showif    = prfs_ReadItem("Entries."+EntryId+".showif");
    entry.blocked    = prfs_ReadItem("Entries."+EntryId+".blocked");
    return entry;
  } else {return ""}
}catch(er){cqerr(er, "prfs_LoadEntry sub")}
}

function prfs_UpdateEntries(){
  entries = EntryHash._Items();
  for (each in entries) {
    id = entries[each].eId;
    var EntryPrefs = prfs_LoadEntry(id);
    if (EntryPrefs) {
      EntryHash[id].Context = EntryPrefs.Context;
      EntryHash[id].showif = EntryPrefs.showif;
      EntryHash[id].blocked = EntryPrefs.blocked;
    } else {EntryHash[id].blocked = false}
  }
}

function prfs_SaveEntries(){
try{
  Prefs.deleteBranch("Entries.");
  var entries = EntryHash._Items();
  for (e in entries){
    if ((!entries[e].Context) || (entries[e].blocked)){
      Prefs.setCharPref("Entries."+entries[e].eId+".eId", entries[e].eId);
      Prefs.setCharPref("Entries."+entries[e].eId+".Title", entries[e].Title);
      //Prefs.setCharPref("Entries."+entries[e].eId+".Method", entries[e].Method);
      //Prefs.setCharPref("Entries."+entries[e].eId+".Desc", entries[e].Desc);
      Prefs.setCharPref("Entries."+entries[e].eId+".filepath", entries[e].filepath);
      Prefs.setBoolPref("Entries."+entries[e].eId+".Context", entries[e].Context);
      Prefs.setBoolPref("Entries."+entries[e].eId+".blocked", entries[e].blocked);
      Prefs.setCharPref("Entries."+entries[e].eId+".showif", entries[e].showif);
      //Prefs.setBoolPref("Entries."+entries[e].eId+".haslist", entries[e].haslist);
    }
	}
}catch(er){cqerr(er, "prfs_SaveEntries sub")}
}

function prfs_ReadItem(name){
	if (Prefs.prefHasUserValue(name)) {
  	var type = Prefs.getPrefType(name);
    if (type & 128) {
      return Prefs.getBoolPref(name);
    } else if (type & 32) {
			return Prefs.getCharPref(name);
    }	else {
			return "";
		}
	} else {return ""}
}


function exploreobj(obj){
  for (each in obj) {
    show("NODE ::: " + each);
    a = obj[each];
      for (i  in  a){
        show(i + " >>> " + a[i]);
      }
    }
}

function explorearr(arr){
  for (each in arr) {
    show(each + " >>> " + arr[each]);
  }
}

function show(str){
  window._content.document.write(str +  " <br>");
}